---
home: false
title: Technical Documentation
layout: Layout
---

# {{ $frontmatter.title }}

The software implemented for the Ahiqar project is realized with several components, which are mainly the following:

Website, Backend, TIDO Viewer and Collation

(Backend: all ETL processes / offering TextAPI, AnnotationAPI and SearchAPI)  
(Tido Viewer: a viewer meant to display digital editions - and everything else delivered via TextAPI)

This is the very fist implementation of the TextAPI - a generic API specification to deliver all kinds of texts and related material like images, serializations and annotations.
A backend made with eXist-db is meant to privde the API, a client application within the browser, TiDO,  
interacts with the TextAPI to persent all the data in a well-known order (e.g. synoptic view with image and a transcription converted to HTML).  
Beforehand the data is prepared with TextGrid.

![UML diagram](https://yuml.me/7474569d.svg)

## Git Repository

All the code used for this project is available at our GitLab: [https://gitlab.gwdg.de/subugoe/ahiqar](https://gitlab.gwdg.de/subugoe/ahiqar)

### GitLab CI

Everything is assambled, tested and deployed with the help of GitLab CI. Please see the `.gitlab-ci.yaml` files in all the repositories.

### Editing TEI

For editing, storing and exporting the TEI documents the virtual research environment TextGrid is used. TextGrid offers all facilities to encode, validate, interlink, store and export the data.

### Schema

Based on the ODD file a conversion to RNG is used for validating documents during the process of encoding utilizing Oxygen XML editor as part of the TextGrid Laboratory.
There is no further validation instances used.

### Export Interfaces

Communicating with TextGrid\`s REST interfaces an XQuery client is available to transfer data to eXist-db. The process can be triggered from within the TextGrid Laboratory (requires the “SADE” plug-in) or from eXist-db (manually or programmatically).

## eXist-db

The main component for the backend implementation is eXist-db offering a performant XQuery processor. ETL-processes are bound together in our backend application ([git repo](https://gitlab.gwdg.de/subugoe/ahiqar/backend), [Expath Package](https://ci.de.dariah.eu/exist-repo/packages/ahikar.html)) as well as the instructions for the REST API created with [RESTXQ](http://exquery.github.io/exquery/exquery-restxq-specification/restxq-1.0-specification.html).

## Interfaces Available to End-Users

Most of the interfaces available to end-users are documented with OpenAPI: [https://ahiqar.uni-goettingen.de/openapi/](https://ahiqar.uni-goettingen.de/openapi/)

In addition, particulary where a desciption is missing at the OpenAPI descriptor file, more extensive documentations can be found via the following URLs:

* [TextAPI especially for Ahiqar](https://subugoe.pages.gwdg.de/ahiqar/api-documentation/page/text-api-specs/)
* [AnnotationAPI for Ahiqar](https://subugoe.pages.gwdg.de/ahiqar/api-documentation/page/annotation-api-specs/)
* [SearchAPI](https://subugoe.pages.gwdg.de/ahiqar/api-documentation/page/search-api-specs/)

A restricted version of eXist-db\`s REST interface is available via [https://ahiqar.uni-goettingen.de/rest/](https://ahiqar.uni-goettingen.de/rest/).

## Website

This website, offering static content and the user interface to search only, is prepared with Vue.js, VuePress and Vuetify.  
Pages are written in Markdown.

## Collation

Using [CollateX](https://github.com/interedition/collatex) with [tokenized version of the manuscripts](https://ahiqar.uni-goettingen.de/api/content/ahikar-json.zip) the output presented at [https://ahiqar.uni-goettingen.de/website/collation.html](https://ahiqar.uni-goettingen.de/website/collation.html) is prepared.
